<template>
  <div class="profile">
    <div class="container">
      <div class="flex w-full mt-10 flex flex-col sm:items-start sm:flex-row">
        <div class="profile-avatar mr-0 sm:mr-10 mb-10 sm:mb-0">
          <p class="text-center text-lg opacity-70 font-bold mb-5">Фото профиля</p>
          <div class="card">
            <Avatar v-model:path="avatar_url" @upload="updateProfile"  class="mt-2"/>
          </div>
        </div>
        <div class="profile-info">
          <p class="text-center text-lg opacity-70 font-bold mb-5">Данные профиля</p>
          <div class="card">
            <form class="form-widget" @submit.prevent="updateProfile">
              <div>
                <label for="email">Телефон</label>
                <input id="phone" type="text" v-model="phone" />
              </div>
              <div>
                <label for="email">Email</label>
                <input id="email" type="text" :value="user.email" disabled />
              </div>
              <div>
                <label for="username">Имя</label>
                <input id="username" type="text" v-model="username" />
              </div>
              <label class="button" for="update">
                {{ loading ? 'Загрузк.. ' : 'Сохранить ' }} <LoadsSpinner v-if="loading" small/>
              </label>
              <input
                style="visibility: hidden; position: absolute"
                type="submit"
                id="update"
                :value="loading ? 'Loading ...' : 'Update'"
                :disabled="loading"
              />
            </form>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { supabase } from "../supabase"
import {useStore} from "vuex";
import {computed, onMounted, ref} from "vue"
import Avatar from '../components/Avatar.vue'
import LoadsSpinner from "../components/Loads-spinner.vue";
export default {
  name: "Profile",
  components: {LoadsSpinner, Avatar},
  setup() {
    const store = useStore()
    let user = computed(function () {
      return store.state.user
    });
    const loading = ref(true)
    const username = ref("")
    const phone = ref("")
    const avatar_url = ref("")

    async function getProfile() {
      try {
        loading.value = true
        user = supabase.auth.user()

        let { data, error, status } = await supabase
          .from("profiles")
          .select(`username, avatar_url, phone`)
          .eq("id", user.id)
          .single()

        if (error && status !== 406) throw error

        if (data) {
          username.value = data.username
          phone.value = data.phone
          avatar_url.value = data.avatar_url
        }
      } catch (error) {
        alert(error.message)
      } finally {
        loading.value = false
      }
    }

    async function updateProfile() {
      try {
        loading.value = true
        user = supabase.auth.user()

        const updates = {
          id: user.id,
          username: username.value,
          avatar_url: avatar_url.value,
          updated_at: new Date(),
          email: user.email,
          phone: phone.value,
        }

        let { error } = await supabase.from("profiles").upsert(updates, {
          returning: "minimal", // Don't return the value after inserting
        })

        if (error) throw error
      } catch (error) {
        alert(error.message)
      } finally {
        loading.value = false
      }
    }

    onMounted(() => {
      getProfile()
    })

    return {
      user,
      loading,
      username,
      avatar_url,
      phone,

      updateProfile,
    }
  },
}
</script>

<style scoped lang="scss">
.profile {
  .container {
    .card {
    }
    .profile-avatar{}
    .profile-info{
      input {
        background-color: white;
        border: 1px solid #cccccc;
      }
    }
  }
}
</style>
